          #include <P16F628A.INC>
            LIST        p=16F628A    ; 
            __CONFIG    H'3F09'      ;  H'3F18'
                                    ; 
            
Sec           equ         20h  ;
Sec1          equ         21h   ; 
Sec2          equ         22h   ;
scetbit       equ         23h   ;
perem         equ         24h    ;
var           equ         25h
desiat        equ         26h    ;
shet          equ         27h
flag1         equ         28h
sotni         equ         29h
edin          equ         2Ah
bcd_code      equ         2Bh
shet1         equ         2Ch
crc           equ         2Dh
crc_tmp       equ         34h
cntr_lcd      equ         32h
shet_t1       equ         33h

dstemp        equ         2Eh
temp          equ         2Fh

reseivebyte   equ         30h
sendbyte      equ         31h


 
flag          equ         35h               ;  
vremya        equ         36h               ;   
kolbyte       equ         37h               ; -  
reg           equ         38h               ;    
shets         equ         39h               ; -  
FSR_osn       equ         4Ah               ;     
FSR_prer      equ         4Bh               ;  

t1L           equ         4Ch
t1H           equ         4Dh
t2L           equ         4Eh

nomer         equ         4Fh
x_adr         equ         50h
y_adr         equ         51h
viv_shet      equ         52h

data1         equ         60h               ;    

W_TEMP        equ         7Eh
STATUS_TEMP   equ         7Fh    ;

#DEFINE       dat  	      PORTB,7           ;   -

#DEFINE       led  	      PORTB,1           ; 


#DEFINE       sdata       PORTB,4
#DEFINE       sclk        PORTB,2
#DEFINE       led_lcd     PORTB,3
#DEFINE       dat_com     PORTB,5
#DEFINE       res_lcd     PORTB,6
#DEFINE       cs          PORTA,1

#DEFINE       knp_led     PORTB,0           ; 
#DEFINE       contrst     PORTA,3

#DEFINE       datchik     PORTA,0



;flag1,0       
;flag1,1        ,   
;flag1,2        ,     10 
;flag1,3        
;flag1,7       
;flag1,4          
;flag1,6          (  )     ----  ERROR
;flag1,5         914  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    4-  
;     4 ,   1 

              org         0000h           ;     0000h
              goto        Start           ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                 
              btfsc       INTCON,RBIF
              goto        prov_tmr0
              btfsc       PIR1,TMR2IF
              goto        prov_tmr2
              btfsc       PIR1,TMR1IF
              goto        prov_tmr1
              
prov_tmr0     movf        TMR0,W            ;   TMR0 
              movwf       vremya            ;  vremya 
              movlw       .0                ;  0   TMR0
              movwf       TMR0 

              movf        FSR,W             ;   FSR 
              movwf       FSR_osn           ; FSR_osn
              movf        FSR_prer,W        ;   FSR_prer 
              movwf       FSR               ; FSR

              btfsc       INTCON,T0IF       ;     TMR0
              goto        outshet           ; TMR0:   outshet

              btfss       dat               ;  TMR0:   
              bcf         flag,0            ;dat  0-   flag1
              btfsc       dat
              bsf         flag,0

             
              movlw       .20               ;   .20
              subwf       vremya,W          ;:- 40
              btfss       STATUS,C          ;
              goto        eror              ;  40:   eror
              movlw       .70               ;  40: :  .70
              subwf       vremya,W          ;- 140
              btfsc       STATUS,C          ;
              goto        int1              ;  140:   int1
              bcf         flag,1            ;  140: 1-   flag:
                                            ;   100
              goto        opred             ;   opred
int1          movlw       .80               ; : - 160 .80
              subwf       vremya,W          ;
              btfss       STATUS,C          ;
              goto        eror              ;  160:   eror
              movlw       .130              ;  160: :  .130
              subwf       vremya,W          ;- 260
              btfsc       STATUS,C          ;
              goto        eror              ;  260:   eror
              bsf         flag,1            ;  260: 1-   
                                            ;flag:   200
opred         btfss       flag,0            ;     dat
              goto        int2              ;   dat:   int2
              btfsc       flag,1            ;   dat(  - 
                                            ;-  ):  
              bsf         flag,2            ; 2-   flag: 
              btfss       flag,1            ;   200
              bcf         flag,2            ; 2-   flag: 
                                            ;   100
              bsf         flag,7            ; 7-   flag: 
                                            ;     -
                                            ;-    
              goto        vihod             ;   vihod

int2          btfss       flag,7            ;   dat:(  -
                                            ;-  ):    
                                            ; 
              goto        vihod             ;     :  
                                            ; vihod
              btfsc       flag,2            ;     :- 
                                            ;-    
              goto        int3              ;    200:   int3
              btfss       flag,1            ;    100:  
                                            ;  
              goto        eror              ;   100(   100)-
                                            ;- :   eror 
              bsf         flag,3            ;   200(  100)- 
                                            ;-   (.1)
              goto        intpriem          ;   intpriem

int3          btfsc       flag,1            ;    200:  
                                            ;  
              goto        eror              ;   200(   200)-
                                            ;- :   eror 
              bcf         flag,3            ;   100(  200)-
                                            ;-   (.0)

intpriem      btfsc       flag,3            ;       0- -
              bsf         reg,0             ;- reg
              btfss       flag,3            ;
              bcf         reg,0             ;
              incf        shets,F           ;  (shets)  
              movlw       .8                ;  (shets)     
              xorwf       shets,W           ;  8
              btfsc       STATUS,Z          ;
              goto        srav              ; , 8 (1 ):   srav
              rlf         reg,F             ; :  reg    
                                            ;   
              goto        vihod             ;   vihod

srav          movf        reg,W             ;   - 
              movwf       INDF              ;-  
              incf        FSR,F             ;  FSR:   
                                            ;
              clrf        shets             ;  
              incf        kolbyte,F         ;  -  
              movlw       .3                ;  (shets)    
              xorwf       kolbyte,W         ;  3
              btfss       STATUS,Z          ;
              goto        vihod             ; :   vihod
              bsf         flag,4            ; , 2 :  -
                                            ;-! 
              goto        eror              ;   eror

outshet       bcf         INTCON,T0IF       ;     TMR0
eror          clrf        shets             ;  
              clrf        kolbyte           ;  
              bcf         flag,7            ;     . 
              movlw       data1             ;     
              movwf       FSR               ;   FSR
 
vihod         movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;      
                                            ;  RB4-RB7
             
kon1          movf        FSR,W             ;   FSR 
              movwf       FSR_prer          ; FSR_prer
              movf        FSR_osn,W         ;   FSR_osn 
              movwf       FSR               ; FSR
              goto        exxit


prov_tmr1     decfsz      t1L,F
              goto        t1
              decfsz      t1H,F
              goto        tt1
              movlw       .114
              movwf       t1L
              movf        shet_t1,W
              movwf       t1H
              bsf         flag1,2
              goto        t1

tt1           movlw       .114
              movwf       t1L
              
t1            bcf         PIR1,TMR1IF
              goto        exxit

prov_tmr2     decfsz      t2L,F
              goto        t2
              bsf         flag1,4
              movlw       .32
              movwf       t2L
t2            bcf         PIR1,TMR2IF
              


exxit         swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

             

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                 
             
Start         movlw       b'01000000'
              movwf       PORTB
              movlw       b'00000010'
              movwf       PORTA
              
              movlw       b'00000111'
              movwf       CMCON

              bsf         STATUS,RP0        
              movlw       b'10000001'          
              movwf       TRISB
              movlw       b'11111101'          
              movwf       TRISA
                         
              movlw       b'10000000'       ;  TMR0 1:2, .  b'10000000'
              movwf       OPTION_REG        ; 
              bcf         STATUS,RP0
                  
              clrf        flag1
              bcf         flag,5            ;  
              bcf         flag,7            ;     .
              bcf         flag,4            ;    
              clrf        shets             ;  
              clrf        kolbyte           ;  
              movlw       data1             ;     
              movwf       FSR_prer          ;  FSR_prer

              movlw       .114
              movwf       t1L
              bsf         STATUS,RP0
              movlw       0x00
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       shet_t1
              
              movlw       .0
              xorwf       shet_t1,W
              btfsc       STATUS,Z
              goto        standrt
              movf        shet_t1,W
              sublw       .15
              btfsc       STATUS,C
              goto        beg1
standrt       movlw       .7
              movwf       shet_t1

beg1          movlw       b'00110000'       ;. TMR1 1:8,     
              movwf       T1CON
              clrf        TMR1L
              clrf        TMR1H
              bsf         INTCON,PEIE       ;. . . 
              bcf         PIR1,TMR1IF       ;  .  . TMR1
              bsf         STATUS,RP0
              bsf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              
              bsf         T1CON,TMR1ON      ; TMR1
 
              movlw       .16
              movwf       t2L
              movlw       b'01111011'       ;. TMR2 1:16,   1:16 
              movwf       T2CON
              clrf        TMR2
              bcf         PIR1,TMR2IF       ;  .  . TMR2
              bsf         STATUS,RP0
              bsf         PIE1,TMR2IE       ;. .  . TMR2
              movlw       .255
              movwf       PR2
              bcf         STATUS,RP0
              bsf         T2CON,TMR2ON      ; TMR2
              

              bcf         INTCON,T0IF       ;     TMR0
              movlw       .0                ; 0  TMR0
              movwf       TMR0              ;
              bsf         INTCON,T0IE       ;    TMR0

              movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;       RB4:RB7
              bsf         INTCON,RBIE       ;      RB4:RB7
              bsf         INTCON,GIE        ;  
              
           

              call        init_lcd

              call        clear_lcd
              
              call        viv_dom         ;  
              bcf         flag1,6         ; -----  
              call        tmp_not 
              call        viv_out       ;  
              bsf         flag1,6         ; -----  
              call        tmp_not             
              
              call        thermometer             

opros         btfsc       flag,4            ;     
              goto        priem1             ;
              btfsc       flag1,2           ;      
              goto        notpriem
              btfsc       flag1,4          ;      
              goto        read_home

oproskn1      btfss       knp_led            ; 1- 
              goto        kn1             ;1-  :    kn1 
              bsf         flag1,3          ;1-   :   1-  
              goto        oproskn2        ;   oproskn2
kn1           btfss       flag1,3          ;   1-  
              goto        oproskn2        ; 1-   :    oproskn2 
              bcf         flag1,3          ;   1-  
              
              btfsc       led_lcd
              goto        met_led1        
              bsf         led_lcd
              goto        oproskn2
met_led1      bcf         led_lcd

oproskn2      btfss       contrst            ; 2- 
              goto        kn2             ;1-  :    kn1 
              bsf         flag1,7          ;1-   :   2- 
              goto        opros          ;   metka1
kn2           btfss       flag1,7          ;   2-  
              goto        opros          ; 2-   :    metka1 
              bcf         flag1,7          ;   2- 
              call        cntrst        ;  program2 
              goto        opros


notpriem      bcf         flag1,2          ; -----      
              bsf         flag1,6
              call        tmp_not
              goto        opros   

         
read_home     bcf         flag1,4        
             call        thermometer
              btfss       flag1,1
              goto        a1  
              bcf         flag1,6           
              call        viv_err              
              goto        opros
a1            call        vivod
              goto        opros


priem1        bsf         led
              bcf         flag,4            ; :   
              movlw       data1             ;
              movwf       FSR               ;
              movf        INDF,W
              movwf       dstemp
              incf        FSR,F
              movf        INDF,W
              movwf       temp
              incf        FSR,F
              movf        INDF,W
              movwf       crc_tmp

              clrf        crc
              movf        dstemp,W
              call        crc_8
              movf        temp,W
              call        crc_8
              movf        crc,W
              xorwf       crc_tmp,W
              btfsc       STATUS,Z
              goto        next1
              bcf         led
              goto        opros
              
next1         bcf         T1CON,TMR1ON      ; TMR1,  
              clrf        TMR1H
              clrf        TMR1L
              movlw       .114
              movwf       t1L
              movf        shet_t1,W
              movwf       t1H
              bcf         flag1,2
              bsf         T1CON,TMR1ON
             
              
              movf        temp,W
              xorlw       b'10101010'
              btfsc       STATUS,Z 
              goto        out_err             ;   :   opros
              call        privid_e
              call        viv_ulica
              bcf         led
              goto        opros
             
      
out_err       bsf         flag1,6
              call        viv_err
              goto        opros

            


viv_ulica     movlw      0x44              ;    Y4
              movwf      y_adr
              call       sendispcom 
              goto      viv_met1
vivod         movlw      0x41              ;    Y1
              movwf      y_adr
              call       sendispcom 
viv_met1      movlw      0x8A              ;
              movwf      x_adr            ;    X10
              call       sendispcom
              call        table
              movwf       temp
              movf        dstemp,W
              movwf       var
              call        razryad

              btfsc       flag1,0         
              goto        minus          ;   .
              movf        dstemp,W
              sublw       .99
              btfsc       STATUS,C
              goto        desyatki       ;.  100   10 .
                                 
             movlw      .11               ;
             call       viv_lcd 
             movlw      .13               ;"+"  .  100 
             call       viv_lcd
             movf       sotni,W
             call       viv_lcd
             movf       desiat,W
             call       viv_lcd
             movf       edin,W
             call       viv_lcd
             movlw      .14               ; 
             call       viv_lcd
             movlw      .15               ;""
             call       viv_lcd                        
             return     

desyatki      movf        dstemp,W
              sublw       .9
              btfsc       STATUS,C
              goto        edinici
              
              movlw      .13               ;"+"  .  100    10 
             call       viv_lcd
             movf       desiat,W           ; 
             call       viv_lcd
             movf       edin,W          ; 
             call       viv_lcd
             movlw       .10               ;"." 
             call       viv_lcd
             movf       temp,W            ; 
             call       viv_lcd
             movlw      .14               ;   
             call       viv_lcd
             movlw      .15               ;""
             call       viv_lcd
             return

                                          ;.  10   0 .
edinici      movlw      .11               ;
             call       viv_lcd           
             movlw      .13               ;"+"  .  10    0 
             call       viv_lcd
             movf       edin,W           ; 
             call       viv_lcd
             movlw       .10              ; '.' 
             call       viv_lcd
             movf       temp,W          ; 
             call       viv_lcd
             movlw      .14               ;  
             call       viv_lcd
             movlw      .15               ;""
             call       viv_lcd 
             return
             

minus         movf        dstemp,W
              sublw       .9
              btfsc       STATUS,C
              goto        otr_edin         ;  . 
                                            ;.  -10,  
              movlw      .11               ;
              call       viv_lcd          
              movlw      .12               ;"-"
              call       viv_lcd
              movf       desiat,W           ; 
              call       viv_lcd
              movf       edin,W          ; 
              call       viv_lcd
              movlw      .14               ;  
             call       viv_lcd
             movlw      .15               ;""
             call       viv_lcd
             movlw      .11               ;
             call       viv_lcd          
             return
                                            ;.  -10,  
otr_edin      movlw      .11               ;
             call       viv_lcd    
             movlw      .12               ;"-"  .  10    0 
             call       viv_lcd
             movf       edin,W           ; 
             call       viv_lcd
             movlw       .10              ; '.' 
             call       viv_lcd
             movf       temp,W          ; 
             call       viv_lcd
             movlw      .14               ;  
             call       viv_lcd
             movlw      .15               ;""
             call       viv_lcd                 
             return
              


sendispcom   movwf      perem            ;    
             bcf        dat_com
             goto       povt1
sendispdat   movwf      perem
             bsf        dat_com
povt1        movlw      .8
             movwf      scetbit
povt2        bcf        sclk
             btfsc      perem,7
             bsf        sdata
             btfss      perem,7
             bcf        sdata
             bsf        sclk                                   
             rlf        perem,F
             decfsz     scetbit,F             
             goto       povt2
             bcf        sclk
             return
        
tmp_not      movlw      0x8A              ;  ( )
             movwf      x_adr            ;    X10
             call       sendispcom
             btfsc      flag1,6
             goto       tmp_1            
             movlw      0x41              ;    Y1
             movwf      y_adr
             call       sendispcom 
             goto       tmp_2
tmp_1        movlw      0x44              ;    Y4
             movwf      y_adr
             call       sendispcom 
tmp_2        movlw      .11               ;
             call       viv_lcd
             movlw      .12               ;"-"
             call       viv_lcd
             movlw      .12               ;"-"
             call       viv_lcd
             movlw      .12               ;"-"
             call       viv_lcd
             movlw      .12               ;"-"
             call       viv_lcd
             movlw      .12               ;"-"
             call       viv_lcd
             movlw      .11               ;
             call       viv_lcd
             return


viv_err      movlw      0x8A              ;  ERROR ( )
             movwf      x_adr            ;    X10
             call       sendispcom
             btfsc      flag1,6
             goto       tmp_3            
             movlw      0x41              ;    Y1
             movwf      y_adr
             call       sendispcom 
             goto       tmp_4
tmp_3        movlw      0x44              ;    Y4
             movwf      y_adr
             call       sendispcom 
tmp_4        movlw      .11               ;
             call       viv_lcd
             movlw      .16               ;"E"
             call       viv_lcd
             movlw      .17               ;"R"
             call       viv_lcd
             movlw      .18               ;"R"
             call       viv_lcd
             movlw      .19               ;"O"
             call       viv_lcd
             movlw      .20               ;"R"
             call       viv_lcd
             movlw      .11               ;
             call       viv_lcd
             return

viv_dom      movlw      0xA1              ;   ;    X33            
             call       sendispcom
             movlw      0x40              ;    Y0
             call       sendispcom
             movlw      .0
             movwf      nomer
             movlw      .18
             movwf      viv_shet
viv_d1       call       tab_rus
             call       sendispdat
             incf       nomer,F
             decfsz     viv_shet,F
             goto       viv_d1
             return

viv_out      movlw      0x9B              ;   ;    X27            
             call       sendispcom
             movlw      0x43              ;    Y3
             call       sendispcom
             movlw      .18
             movwf      nomer
             movlw      .30
             movwf      viv_shet
viv_d2       call       tab_rus
             call       sendispdat
             incf       nomer,F
             decfsz     viv_shet,F
             goto       viv_d2
             return

init_lcd     bcf        res_lcd           
             nop
             nop
             bsf        res_lcd
             nop
             nop
             bcf        cs
             

             movlw      0x21              ;  , .,   
             call       sendispcom        ;
             movlw      0x13              ;   Bias 1:48
             call       sendispcom        ;
             movlw      0x04              ;   4
             call       sendispcom
             movlw      0xC1              ;  ( Vop) 6,42 (0B8)
             movwf      cntr_lcd
             call       sendispcom
             movlw      0x20              ;  
             call       sendispcom  
             movlw      0x0C              ; -   
             call       sendispcom 
             return


clear_lcd    movlw      0x40              ;    Y0
             call       sendispcom 
             movlw      0x80              ;    X0
             call       sendispcom 
             movlw      .6
             movwf      Sec1
povt4        movlw      .84
             movwf      Sec
povt3        movlw      .0
             call       sendispdat
             decfsz     Sec,F             
             goto       povt3
             decfsz     Sec1,F             
             goto       povt4
             return


cntrst       btfsc      flag,5           ;  
             goto       cnt_minus
cnt_plus     movlw      0xD0
             xorwf      cntr_lcd,W
             btfss      STATUS,Z
             goto       cnt_11
             bsf        flag,5
             goto       cnt_minus
cnt_11       movlw      .3
             addwf      cntr_lcd,F  
             goto       cnt_22 
 
cnt_minus    movlw      0xB2
             xorwf      cntr_lcd,W
             btfss      STATUS,Z
             goto       cnt_33
             bcf        flag,5
             goto       cnt_plus
cnt_33       movlw      .3
             subwf      cntr_lcd,F  
             
         
cnt_22       movlw      0x21              ;  , .,   
             call       sendispcom        ;
             movf       cntr_lcd,W              ;
             call       sendispcom        ;
             movlw      0x20              ;  
             call       sendispcom
             return
             

thermometer     bcf      INTCON,GIE

                call     init_therm         
                btfss    flag1,1
                goto     ds_enable
                
therm1          bsf      INTCON,GIE
                return

		
ds_enable       movlw    0xCC	            ; 
                call     send1
                movlw    0x44
                call     send1

end_ansv1       btfss    datchik	     ;  
                goto     end_ansv1
                call     init_therm        ; 
                movlw    0xCC	           ; 
                call     send1
                movlw    0xBE
                call     send1
                call     reseive
                movwf    dstemp
                call     reseive
                movwf    temp
                call     privid_e
                goto     therm1
               
    

init_therm      bcf          flag1,1	            ;,   
                movlw        .20	            ;  
                movwf        Sec1
                call         ds_comm
                bcf          datchik	          ;
                movlw        .170	            ; 500 
                movwf        Sec
delinittherm    decfsz       Sec,F
                goto         delinittherm
                bsf          datchik
                call         ds_data
init_ansv       btfss        datchik	           ; 
                goto         end_ansv
                decfsz      Sec1,F
                goto        init_ansv
                bsf         flag1,1	      ;   >  
                return

end_ansv        btfss       datchik	     ;  
                goto        end_ansv
                return

send1           movwf       sendbyte	      ;  
                movlw      .8
                movwf        Sec1
sendloop        call       ds_comm
                rrf        sendbyte,F
                btfsc      STATUS,C
                bsf        datchik
                call       wait50
                call       ds_data
                decfsz     Sec1,F
                goto       sendloop
                return
		
reseive         movlw      .8
                movwf     Sec1
reseiveloop     call      ds_comm
                call      ds_data
                bcf       STATUS,C
                btfsc     datchik
                bsf       STATUS,C
                rrf       reseivebyte,F 
                call      wait50
                decfsz    Sec1,F
                goto      reseiveloop
                movf      reseivebyte,W
                return



ds_comm       bcf        datchik                    ;  
              bsf        STATUS,RP0
              bcf        TRISA,0
              bcf        STATUS,RP0
              return


ds_data       bsf        STATUS,RP0                 ;  
              bsf        TRISA,0
              bcf        STATUS,RP0
              return


privid_e        bcf        flag1,0           ;   .
                btfss      temp,7           ;  
                goto       pls1             ;. .   pls1

                bsf        flag1,0           ;.  . .
                movlw      .1               ;    .  
                subwf      dstemp,F         ;temp, dstemp,    
                btfss      STATUS,C
                decf       temp,F

pls1            movlw      .4               ;   .   dstemp
                movwf      Sec              ;  .    
                bcf        STATUS,C         ;  temp
met1            rrf        temp,F
                rrf        dstemp,F
                decfsz     Sec,F
                goto       met1
                rrf        temp,F

                btfss     flag1,0            ;  ( )
                goto      pls2              ;. .   pls2
                comf      dstemp,F          ;. :     dstemp
                swapf     temp,F            ;    temp
                comf      temp,W            ;   temp
                andlw     b'00001111'       ;     
                movwf     temp              ;   .
                return

pls2            swapf     temp,W            ;    temp
                andlw     b'00001111'       ;     
                movwf     temp              ;   .
		        return	




razryad     clrf        sotni
pr0         incf        sotni,F ; 
            movlw       .100
            subwf       var,F
            btfsc       STATUS,C
            goto        pr0
            decf        sotni,F
            movlw       .100
            addwf       var,F
            clrf        desiat
pr1         incf        desiat,F ; 
            movlw       .10
            subwf       var,F
            btfsc       STATUS,C
            goto        pr1
            decf        desiat,F
            movlw       .10
            addwf       var,F
            clrf        edin
pr2         incf        edin,F ; 
            movlw       .1
            subwf       var,F
            btfsc       STATUS,C
            goto        pr2
            decf        edin,F
            return



crc_8         xorwf       crc,F           ;   
              clrw
              btfsc       crc,7
              xorlw       0x7A
              btfsc       crc,6
              xorlw       0x3D
              btfsc       crc,5
              xorlw       0x86
              btfsc       crc,4
              xorlw       0x43
              btfsc       crc,3
              xorlw       0xB9
              btfsc       crc,2
              xorlw       0xC4
              btfsc       crc,1
              xorlw       0x62
              btfsc       crc,0
              xorlw       0x31
              movwf       crc
              return


wait50        movlw       .12                     ; 50
              movwf       Sec
loop50        nop
              decfsz      Sec,F
              goto        loop50
              return

pauslcd       movlw       .2             ; 1,4 
              movwf       Sec1
pk3            movlw       .255
              movwf       Sec             ;
pk2            decfsz      Sec,F           ;
              goto        pk2              ;
              decfsz      Sec1,F          ;
              goto        pk3              ;
              return           


pausknp       movlw       .50             ; 19 
              movwf       Sec1
p3            movlw       .255
              movwf       Sec             ;
p2            decfsz      Sec,F           ;
              goto        p2              ;
              decfsz      Sec1,F          ;
              goto        p3              ;
              return                      ;
                                          ;
             
pause1s       movlw       .5             ; 1 
              movwf       Sec2
pp3           movlw       .255
              movwf       Sec1
pp2           movlw       .255
              movwf       Sec             ;
pp1           decfsz      Sec,F           ;
              goto        pp1              ;
              decfsz      Sec1,F          ;
              goto        pp2  
              decfsz      Sec2,F          ;
              goto        pp3              ;
              return                      


table         movlw       high tab                ;     tab  
              movwf       PCLATH                  ; PCLATH
              movf        temp,W                 ;      
              addlw       low tab                 ;    tab   W
              btfsc       STATUS,C                ;  W   
              incf        PCLATH,F                ;  W:  PCLATH 
              movf        temp,W                 ;   W:  
              addwf       PCL,F                   ;     PCL

tab           dt 0x00, 0x00, 0x01, 0x02, 0x02;    ;   
              dt 0x03, 0x04, 0x04, 0x05, 0x06;    ;
              dt 0x06, 0x07, 0x07, 0x08, 0x09;    ;
              dt 0x09; 



viv_lcd      movwf      nomer          ;  ,    
             sublw      .9
             btfss      STATUS,C
             goto       viv_znk
             
viv_chislo   movlw      .19            ;    20
             movwf      viv_shet
             movf       nomer,W
viv_3        addwf      nomer,F
             decfsz     viv_shet,F
             goto       viv_3
             bcf        flag1,5
     

viv_2        movlw      .10
             movwf      viv_shet
viv_1        call       tab_123
             call       sendispdat
             incf       nomer,F
             incf       x_adr,F
             decfsz     viv_shet,F
             goto       viv_1

             btfsc      flag1,5
             goto       viv_4
         
             movlw      .10
             subwf      x_adr,F
             incf       y_adr,F
             movf       y_adr,W          ;    Y(x)+1
             call       sendispcom 
             movf       x_adr,W             ;    X(x)-10
             call       sendispcom 
             bsf        flag1,5
             goto       viv_2

viv_4        decf       y_adr,F
             movf       y_adr,W          ;    Y(x)-1
             call       sendispcom 
             return

viv_znk      movlw      .10
             subwf      nomer,F
    
viv_znak     movlw      .19            ;    20
             movwf      viv_shet
             movf       nomer,W
viv_5        addwf      nomer,F
             decfsz     viv_shet,F
             goto       viv_5
             bcf        flag1,5
     

viv_6        movlw      .10
             movwf      viv_shet
viv_7        call       tab_znk
             call       sendispdat
             incf       nomer,F
             incf       x_adr,F
             decfsz     viv_shet,F
             goto       viv_7

             btfsc      flag1,5
             goto       viv_8
         
             movlw      .10
             subwf      x_adr,F
             incf       y_adr,F
             movf       y_adr,W          ;    Y(x)+1
             call       sendispcom 
             movf       x_adr,W             ;    X(x)-10
             call       sendispcom 
             bsf        flag1,5
             goto       viv_6

viv_8        decf       y_adr,F
             movf       y_adr,W          ;    Y(x)-1
             call       sendispcom 
             return


;  ()  9 x 14   

tab_123       movlw       high tab1                ;     tab  
              movwf       PCLATH                  ; PCLATH
              movf        nomer,W                 ;      
              addlw       low tab1                 ;    tab   W
              btfsc       STATUS,C                ;  W   
              incf        PCLATH,F                ;  W:  PCLATH 
              movf        nomer,W                 ;   W:  
              addwf       PCL,F                   ;     PCL
 
tab1  dt 0xfc,0xfe,0x03,0x83,0xc3,0x63,0x33,0xfe,0xfc,0x00  ; 
      dt 0x0f,0x1f,0x33,0x31,0x30,0x30,0x30,0x1f,0x0f,0x00  ; '0'
      dt 0x00,0x10,0x18,0x1c,0xfe,0xff,0x00,0x00,0x00,0x00  ; 
      dt 0x00,0x30,0x30,0x30,0x3f,0x3f,0x30,0x30,0x30,0x00  ; '1'
      dt 0x0c,0x0e,0x03,0x03,0x03,0x83,0xc3,0x7e,0x3c,0x00  ; 
      dt 0x30,0x38,0x3c,0x36,0x33,0x31,0x30,0x30,0x30,0x00  ; '2'
      dt 0x0c,0x0e,0x03,0xc3,0xc3,0xc3,0xc3,0xfe,0x3c,0x00  ; 
      dt 0x0c,0x1c,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f,0x00  ; '3'
      dt 0xc0,0xe0,0xb0,0x98,0x8c,0x86,0x83,0xff,0xff,0x00  ; 
      dt 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x3f,0x3f,0x00  ; '4'
      dt 0x3f,0x7f,0x63,0x63,0x63,0x63,0x63,0xe3,0xc3,0x00  ; 
      dt 0x1c,0x3c,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f,0x00  ; '5'
      dt 0xfe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc7,0x86,0x00  ; 
      dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f,0x00  ; '6'
      dt 0x00,0x03,0x03,0x03,0x03,0x83,0xc3,0x7f,0x3f,0x00  ; 
      dt 0x00,0x00,0x00,0x3e,0x3f,0x01,0x00,0x00,0x00,0x00  ; '7'
      dt 0xbe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xbe,0x00  ; 
      dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f,0x00  ; '8'
      dt 0x7e,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xfe,0x00  ; 
      dt 0x18,0x38,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f,0x00  ; '9'


;  (, )  9 x 14 

tab_znk       movlw       high tab2                ;     tab  
              movwf       PCLATH                  ; PCLATH
              movf        nomer,W                 ;      
              addlw       low tab2                 ;    tab   W
              btfsc       STATUS,C                ;  W   
              incf        PCLATH,F                ;  W:  PCLATH 
              movf        nomer,W                 ;   W:  
              addwf       PCL,F                   ;     PCL
 
tab2  dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  ; 
      dt 0x00,0x00,0x00,0x3c,0x3c,0x3c,0x00,0x00,0x00,0x00  ; '.'     10
      dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  ; 
      dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  ; ' '    11
      dt 0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00,0x00  ; 
      dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  ; '-'     12
      dt 0xc0,0xc0,0xc0,0xf8,0xf8,0xc0,0xc0,0xc0,0x00,0x00  ; 
      dt 0x00,0x00,0x00,0x07,0x07,0x00,0x00,0x00,0x00,0x00  ; '+'      13
      dt 0x00,0x1c,0x3e,0x63,0x63,0x63,0x3e,0x1c,0x00,0x00  ; 
      dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  ; '.'    14
      dt 0xfc,0xfc,0x03,0x03,0x03,0x03,0x03,0x0c,0x0c,0x00  ; 
      dt 0x0f,0x0f,0x30,0x30,0x30,0x30,0x30,0x0c,0x0c,0x00  ; 'C'   15
      dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0x03,0x00  ; 
      dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x00  ; 'E'   16
      dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c,0x00  ; 
      dt 0x3f,0x3f,0x01,0x03,0x06,0x0c,0x18,0x30,0x20,0x00  ; 'R'
      dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c,0x00  ; 
      dt 0x3f,0x3f,0x01,0x03,0x06,0x0c,0x18,0x30,0x20,0x00  ; 'R'
      dt 0xfc,0xfe,0x03,0x03,0x03,0x03,0x03,0xfe,0xfc,0x00  ; 
      dt 0x0f,0x1f,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f,0x00  ; 'O'
      dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c,0x00  ; 
      dt 0x3f,0x3f,0x01,0x03,0x06,0x0c,0x18,0x30,0x20,0x00  ; 'R'



tab_rus       movlw       high tab3                ;     tab  
              movwf       PCLATH                  ; PCLATH
              movf        nomer,W                 ;      
              addlw       low tab3                 ;    tab   W
              btfsc       STATUS,C                ;  W   
              incf        PCLATH,F                ;  W:  PCLATH 
              movf        nomer,W                 ;   W:  
              addwf       PCL,F  
                                                  ;     PCL
tab3  dt 0x60, 0x3E, 0x21, 0x3F, 0x60, 0x00  ;// 
      dt 0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00  ;// O
      dt 0x7F, 0x02, 0x04, 0x02, 0x7F, 0x00  ;// M
      dt 0x27, 0x48, 0x48, 0x48, 0x3F, 0x00  ;// 
      dt 0x40, 0x3E, 0x01, 0x01, 0x7E, 0x00  ;// 
      dt 0x7F, 0x10, 0x08, 0x04, 0x7F, 0x00  ;// 
      dt 0x3F, 0x20, 0x20, 0x3F, 0x40, 0x00  ;// 
      dt 0x7E, 0x11, 0x11, 0x11, 0x7E, 0x00  ;// A

	                 end
